<!DOCTYPE html>
<html lang="ru">
<head>
  <meta charset="utf-8">
  <title>Основные действия над изображением</title>
</head>
<body>

<form method="post">
 <select name="action" size="1">
  <option value="0">Ничего не делать</option>
  <option value="1">Уменьшить в 2 раза</option>
  <option value="2">Увеличить в 2 раза</option>
  <option value="3">Вырезать 256 x 256 пикселей по центру</option>
  <option value="4">Повернуть на 30 градусов влево</option>
  <option value="5">Повернуть на 30 градусов вправо</option>
  <option value="6">Отразить по горизонтали</option>
  <option value="7">Отразить по вертикали</option>
  <option value="8">Отразить в 2 направлениях</option>
  <option value="9">Наложить Watermark справа внизу</option>
  <option value="10">Наложить фон (для PNG с прозрачным фоном)</option>
  <option value="11">Фильтр "Инверсия цвета"</option>
  <option value="12">Фильтр "Градации серого"</option>
  <option value="13">Фильтр "Градации заданного цвета" (красного)</option>
  <option value="14">Фильтр "Градации заданного цвета" (зелёного)</option>
  <option value="15">Фильтр "Градации заданного цвета" (синего)</option>
  <option value="16">Фильтр "Яркость" (светлее)</option>
  <option value="17">Фильтр "Яркость" (темнее)</option>
  <option value="18">Фильтр "Контраст" (сильнее)</option>
  <option value="19">Фильтр "Контраст" (слабее)</option>
  <option value="20">Фильтр "Определение границ"</option>
  <option value="21">Фильтр "Рельеф"</option>
  <option value="22">Фильтр "Размытие по Гауссу"</option>
  <option value="23">Фильтр "Эскиз"</option>
  <option value="24">Фильтр "Сглаживание" (-4)</option>
  <option value="25">Фильтр "Пикселизация" (4)</option>
 </select>
 <input type="submit" value="OK">
</form>

<?php
 $filename = 'Lenna.png'; //файл для обработки

 if (!file_exists($filename) or !is_file($filename)) {
  die ('Файл '.$filename.' не существует на сервере');
 }
 if (!isset($_POST['action'])) {
  printImgFile ($filename, 'Исходное изображение');
  exitMe();
 }
 $action = intval(htmlspecialchars(trim($_POST['action']),ENT_QUOTES,'UTF-8'));
 $img = createImg ($filename);
 $img2 = null;
 
 switch ($action) {
  case 0: printImgFile ($filename, 'Исходное изображение'); exitMe(); break;
  case 1: $img2 = scaleImg ($img, 0.5); break;
  case 2: $img2 = scaleImg ($img, 2); break;
  case 3: $img2 = cropImg ($img, '50%', '50%', 256, 256); break;
  case 4: $img2 = rotateImg ($img, 30); break;
  case 5: $img2 = rotateImg ($img, -30); break;
  case 6: $img2 = flipImg ($img, IMG_FLIP_HORIZONTAL); break;
  case 7: $img2 = flipImg ($img, IMG_FLIP_VERTICAL); break;
  case 8: $img2 = flipImg ($img, IMG_FLIP_BOTH); break;
  case 9: $img2 = waterImg ($img, '100%', '100%', 'watermark.png'); break;
  case 10: 
   $img = createImg ('watermark.png');
   $img2 = backgroundImg ($img, '50%', '50%', 'back.png'); 
  break;
  case 11: $img2 = filterImg ($img, IMG_FILTER_NEGATE); break;
  case 12: $img2 = filterImg ($img, IMG_FILTER_GRAYSCALE); break;
  case 13: $img2 = filterImgColor ($img, IMG_FILTER_COLORIZE, 255, 0, 0); break;
  case 14: $img2 = filterImgColor ($img, IMG_FILTER_COLORIZE, 0, 255, 0); break;
  case 15: $img2 = filterImgColor ($img, IMG_FILTER_COLORIZE, 0, 0, 255); break;
  case 16: $img2 = filterImgLight ($img, IMG_FILTER_BRIGHTNESS, 100, 255); break; 
  case 17: $img2 = filterImgLight ($img, IMG_FILTER_BRIGHTNESS, -100, 255); break;
   //последний аргумент - яркость, от -255 до 255
  case 18: $img2 = filterImgLight ($img, IMG_FILTER_CONTRAST, -50, 100); break;
  case 19: $img2 = filterImgLight ($img, IMG_FILTER_CONTRAST, 50, 100); break;
   //последний аргумент - контраст, от -100 (сильный) до 100 (нет)
  case 20: $img2 = filterImg ($img, IMG_FILTER_EDGEDETECT); break;
  case 21: $img2 = filterImg ($img, IMG_FILTER_EMBOSS); break;
  case 22: $img2 = filterImg ($img, IMG_FILTER_GAUSSIAN_BLUR); break;
  case 23: $img2 = filterImg ($img, IMG_FILTER_MEAN_REMOVAL); break;
  case 24: $img2 = filterImgLight ($img, IMG_FILTER_SMOOTH, -4, 8); break;
   //Эффекты сглаживания заметны при 3=м аргументе от 0 до -8
  case 25: $img2 = filterImgLight ($img, IMG_FILTER_PIXELATE, 4, 10); break;  
   //4-й аргумент здесь произволен
  default: die ('Указана недопустимая операция'); break;
 }
 saveImg ($img2);
 printImgFile ($img2['filename'], 'Преобразованное изображение');
 exitMe();

 ///////////////////////////////////////////////////////////////////////////////
 // Функции для работы с изображениями
 ///////////////////////////////////////////////////////////////////////////////

function createImg ($filename) {
 $finfo = finfo_open (FILEINFO_MIME_TYPE); //возвращает MIME-тип
 $mime = finfo_file ($finfo, $filename); 
 finfo_close ($finfo);
 $mime_legal = ['image/gif', 'image/jpeg', 'image/png', 'image/x-png'];
 if (!in_array($mime,$mime_legal)) die ('Неверный тип файла, выберите .gif, .jpg или .png');
 $info   = getimagesize ($filename); //информация о изображении
 $width  = $info[0];
 $height = $info[1];
 $type   = $info[2];
 $img = null;
 switch ($type) { 
  case 1: 
   $img = imageCreateFromGif ($filename);
   imageSaveAlpha ($img, true);
  break;					
  case 2: 
   $img = imageCreateFromJpeg ($filename);
  break;
  case 3: 
   $img = imageCreateFromPng ($filename); 
   imageSaveAlpha ($img, true);
  break;
 }
 if ($img === false) die ('Ошибка создания ресурса из изображения '.$filename);
 $path_parts = pathinfo ($filename);
 $filename2 = $path_parts['filename'].'2.'.$path_parts['extension'];
 return ['img'=>$img, 'width'=>$width, 'height'=>$height, 'type'=>$type, 'filename'=>$filename2];
}

function saveImg ($img) { //Сохранить в файл на сервере
 $src = $img['filename'];
 $result = false;
 switch ($img['type']) {
  case 1: $result = imageGif ($img['img'],$src); break;
  case 2: $result = imageJpeg ($img['img'], $src, 100); break;
  case 3: $result = imagePng ($img['img'], $src); break;
 }
 if ($result === false) die ('Ошибка сохранения файла '.$src);
}

function scaleImg ($img, $scale) { //Масштабировать в $scale раз
 $w = ceil($img['width']*$scale);
 $h = ceil($img['height']*$scale);
 $tmp = imageCreateTrueColor ($w, $h);
 if ($img['type'] == 1 || $img['type'] == 3) $tmp = makeTransparent ($tmp,[255,255,255]);
 $tw = ceil($h / ($img['height'] / $img['width']));
 $th = ceil($w / ($img['width'] / $img['height']));
 if ($tw < $w) {
  imageCopyResampled ($tmp,$img['img'],ceil(($w-$tw)/2),0,0,0,$tw,$h,$img['width'],$img['height']);
 } 
 else {
  imageCopyResampled ($tmp,$img['img'],0,ceil(($h-$th)/2),0,0,$w,$th,$img['width'],$img['height']);
 }            
 return ['img'=>$tmp, 'width'=>$w, 'height'=>$h, 'type'=>$img['type'], 'filename'=>$img['filename']];
}

function cropImg ($img, $x, $y, $w, $h) {
 //изображение, начальные координаты (пиксели или %), размер вырезаемой части (пиксели)
 if (mb_strpos(''.$x,'%',0,'UTF-8') !== false) {
  $x = intval($x); $x = ceil (($img['width'] * $x / 100) - ($w / 100 * $x));
 }
 if (mb_strpos(''.$y,'%') !== false) {
  $y = intval($y); $y = ceil(($img['height'] * $y / 100) - ($h / 100 * $y));
 }
 $tmp = imageCreateTrueColor ($w, $h);
 if ($img['type'] == 1 || $img['type'] == 3) $tmp = makeTransparent ($tmp,[255,255,255]);
 imageCopyResampled ($tmp,$img['img'],0,0,$x,$y,$img['width'],$img['height'],$img['width'],$img['height']);
 return ['img'=>$tmp, 'width'=>$w, 'height'=>$h, 'type'=>$img['type'], 'filename'=>$img['filename']];
}

function rotateImg ($img, $angle) {
 //повернуть на заданный в градусах угол против часовой стрелки, 
 //отрицательный угол меняет направление поворота
 $transparent = imagecolorallocatealpha($img['img'], 255, 255, 255, 127); 
 $tmp = imagerotate ($img['img'], $angle, $transparent);
 if ($tmp === false) die ('Ошибка поворота изображения '.$img['filename']);
 saveImg (['img'=>$tmp, 'type'=>$img['type'], 'filename'=>$img['filename']]);
 $info = getimagesize ($img['filename']);
 return ['img'=>$tmp, 'width'=>$info[0], 'height'=>$info[1], 'type'=>$info[2], 'filename'=>$img['filename']];
}

function flipImg ($img, $mode) {
 //отразить в режиме $mode
 $result = imageflip ($img['img'], $mode);
 if ($result === false) die ('Ошибка поворота изображения '.$img['filename']);
 return ['img'=>$img['img'], 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']];
}

function backgroundImg ($img, $x, $y, $file) {
 //Наложить фон из файла $file в позицию $x, $y (пиксели или %)
 if (!file_exists($file) or !is_file($file)) {
  die ('Файл '.$file.' не существует на сервере');
 }
 $bg = createImg ($file);
 if (mb_strpos(''.$x,'%',0,'UTF-8') !== false) {
  $x = intval($x); $x = ceil (($bg['width'] * $x / 100) - ($img['width'] / 100 * $x));
 }
 if (mb_strpos(''.$y,'%') !== false) {
  $y = intval($y); $y = ceil(($bg['height'] * $y / 100) - ($img['height'] / 100 * $y));
 }
 $tmp = imageCreateTrueColor ($img['width'], $img['height']);
 $result = imagecopy ($tmp, $bg['img'], 0, 0, $x, $y, $img['width'], $img['height']); 
 imagedestroy ($bg['img']);
 if ($result === false) die ('Ошибка наложения '.$file.' под '.$img['filename']);
 $result = imagecopy ($tmp, $img['img'], 0, 0, 0, 0, $img['width'], $img['height']); 
 if ($result === false) die ('Ошибка наложения '.$file.' под '.$img['filename']);
 return ['img'=>$tmp, 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']]; 
}

function waterImg ($img, $x, $y, $watermark) {
 //Наложить watermark из файла $watermark в позицию $x, $y (пиксели или %)
 if (!file_exists($watermark) or !is_file($watermark)) {
  die ('Файл '.$watermark.' не существует на сервере');
 }
 $tmp = createImg ($watermark);
 if (mb_strpos(''.$x,'%',0,'UTF-8') !== false) {
  $x = intval($x); $x = ceil (($img['width'] * $x / 100) - ($tmp['width'] / 100 * $x));
 }
 if (mb_strpos(''.$y,'%') !== false) {
  $y = intval($y); $y = ceil(($img['height'] * $y / 100) - ($tmp['height'] / 100 * $y));
 }
 $result = imagecopy ($img['img'], $tmp['img'], $x, $y, 0, 0, $tmp['width'], $tmp['height']); 
 imagedestroy ($tmp['img']);
 if ($result === false) die ('Ошибка наложения '.$watermark.' на '.$img['filename']);
 return ['img'=>$img['img'], 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']];
}

function filterImg ($img, $filtertype) {
 //Наложение фильтра $filtertype
 $result = imagefilter($img['img'], $filtertype);
 if ($result === false) die ('Ошибка применения фильтра '.$filtertype.' для '.$img['filename']);
 return ['img'=>$img['img'], 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']]; 
}

function filterImgColor ($img, $filtertype, $r, $g, $b) {
 //Наложение фильтра $filtertype с цветом $r, $g, $b
 $result = imagefilter($img['img'], $filtertype, $r, $g, $b);
 if ($result === false) die ('Ошибка применения фильтра '.$filtertype.' для '.$img['filename']);
 return ['img'=>$img['img'], 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']]; 
}

function filterImgLight ($img, $filtertype, $val, $limit) {
 //Наложение фильтра $filtertype с уровнем $val в пределах [-$limit;$limit]
 $val = intval($val); $val = max(-$limit,min($limit,$val));
 $result = imagefilter($img['img'], $filtertype, $val);
 if ($result === false) die ('Ошибка применения фильтра '.$filtertype.' для '.$img['filename']);
 return ['img'=>$img['img'], 'width'=>$img['width'], 'height'=>$img['height'], 
  'type'=>$img['type'], 'filename'=>$img['filename']]; 
}

 ///////////////////////////////////////////////////////////////////////////////
 // Служебные функции
 ///////////////////////////////////////////////////////////////////////////////

 function makeTransparent ($tmp, $rgb) {
  //сделать цвет $rgb прозрачным для ресурса изображения $tmp
  imagealphablending ($tmp, true); 
  imageSaveAlpha ($tmp, true);
  $transparent = imagecolorallocatealpha($tmp, $rgb[0], $rgb[1], $rgb[2], 127); 
  imagefill ($tmp, 0, 0, $transparent); 
  imagecolortransparent ($tmp, $transparent);
  return $tmp;
 }

 function printImgFile ($filename, $alt='') { //Вывести в браузер
  echo '<p><img src="'.$filename.'" alt="'.$alt.'" title="'.$alt.'"></p>';
 }

 function exitMe() {
  echo "\n".'<p><a href="http://blog.kislenko.net/?id=2604">страница скрипта</a></p></body></html>';
  exit(0);
 }
?>